/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package p4uclient;

import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.RandomAccessFile;
import java.net.Socket;

/**
 * ファイル送信タスク
 * @author hosaka
 */
public class TaskUpload extends TaskAbstract implements Runnable {
    private Socket         socket = null;
    private BufferedReader reader = null;
    private PrintWriter    writer = null;
    private Thread         thread = null;
    private FileItem       item   = null;
    private long           loaded = 0;
    private RandomAccessFile     ifstream = null;
    private BufferedOutputStream osstream = null;
    
    public TaskUpload(Socket socket) throws Exception {
        this.socket = socket;
        // 文字コードの設定
        reader = new BufferedReader(new InputStreamReader(
                socket.getInputStream(), "JISAUTODETECT"));
        writer = new PrintWriter(new OutputStreamWriter(
                socket.getOutputStream(), "Shift_JIS"));
        // 処理を開始
        thread = new Thread(this);
        thread.start();
        MainApp.window.modelTasks.addItem(this);
    }
    
    public void run() {
        try {
            String digest = reader.readLine();
            item = MainApp.files.getItem(digest);
            send();
            MainApp.window.putMessage("o 送信完了 <" + item.name + ">");
        } catch(Exception e) {
            MainApp.window.putMessage("x 送信中断");
            MainApp.window.putMessage("debug: " + e);
        } finally {
            try {
                close();
            } catch(Exception e) {
            }
        }
    }
    
    private int readFully(byte[] buf) throws Exception {
        int offset = 0;
        int remain = buf.length;
        while (remain > 0) {
            long tmp = ifstream.read(buf, offset, remain);
            if (tmp < 0) break;
            remain -= tmp;
            offset += tmp;
        }
        return offset;
    }
    
    private void send() throws Exception {
        // ランダムアクセス用に開く
        ifstream  = new RandomAccessFile(MainApp.option.updir + item.name, "r");
        osstream  = new BufferedOutputStream(socket.getOutputStream());
        byte[] buf = new byte[128*1024];
        // シーク位置を決定
        loaded = Long.parseLong(reader.readLine());
        ifstream.seek(loaded);
        // アップロード
        while (item.size - loaded > 0) {
            int tmp = readFully(buf);
            if (tmp == 0) break;
            osstream.write(buf, 0, tmp);
            loaded += tmp;
            MainApp.window.modelTasks.updateItem(this);
        }
    }
    
    @Override public void close() throws Exception {
        if (ifstream != null) ifstream.close();
        if (osstream != null) osstream.close();
        if (writer != null) writer.close();
        if (socket != null) socket.close();
        MainApp.window.modelTasks.deleteItem(this);
    }

    @Override public String getName() {
        return (item != null) ? item.name : "未取得";
    }

    @Override public String getType() {
        return "送信タスク";
    }

    @Override public String getStatus() {
        long length = (item != null) ? item.size : -1;
        int per = (int)((double) loaded / length * 100.0);
        return per + "% - " + loaded + "/" + length;
    }
}
